-- name: [CS] Watto!
-- description: A Template for Character Select to build off of when making your own pack!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
]]

local TEXT_MOD_NAME = "Watto"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_CUSTOM_MODEL = smlua_model_util_get_id("watto_geo") -- Located in "actors"

local TEX_CUSTOM_LIFE_ICON = get_texture_info("watto_life") -- Located in "textures"
--local TEX_CUSTOM_STAR_ICON = get_texture_info("exclamation-icon") -- Located in "textures"

-- All Located in "sound"
local VOICETABLE_CHAR = {
    [CHAR_SOUND_ATTACKED] = 'ATTACKED2.ogg',
    [CHAR_SOUND_DOH] = 'DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'WATTO_DROWN.ogg',
    [CHAR_SOUND_DYING] = 'DYING.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'GROUND_PAD_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'HAHA2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = 'HOOHOO.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'MAMMA_MIA.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'OKEY_DOKEY.ogg',
    [CHAR_SOUND_ON_FIRE] = 'ON_FIRE.ogg',
    [CHAR_SOUND_OOOF] = 'OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'OOF2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'YIPPE2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'WAH2.ogg',
    [CHAR_SOUND_WHOA] = 'WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'YAHOO.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'YIPPE.ogg', 'YIPPE2.ogg', 'YIPPE3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = 'PUNCH_YAH.ogg',
    [CHAR_SOUND_YAWNING] = 'IM_A_TIRE.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Lets_a_go.ogg',
	[CHAR_SOUND_EEUH] = 'LEDGE.ogg',
	[CHAR_SOUND_COUGHING1] = 'COUGHING1.ogg',
	[CHAR_SOUND_COUGHING2] = 'COUGHING2.ogg',
	[CHAR_SOUND_COUGHING3] = 'COUGHING3.ogg',
	[CHAR_SOUND_YAWNING] = 'YAWNING.ogg',
	[CHAR_SOUND_UH] = 'UH.ogg',
	[CHAR_SOUND_UH2] = 'UH2.ogg',
	[CHAR_SOUND_UH2_2] = 'UH2_2.ogg',
	[CHAR_SOUND_PANTING] = 'UH2_2.ogg',
	[CHAR_SOUND_PANTING_COLD] = 'PANTING_COLD.ogg',
	[CHAR_SOUND_SNORING1] = 'SNORING.ogg',
	[CHAR_SOUND_SNORING2] = 'SNORING2.ogg',
	[CHAR_SOUND_SNORING3] = { 'SNORING2.ogg', 'SNORING.ogg', 'SNORING3.ogg'},
	[CHAR_SOUND_HRMM] = 'HRMM2.ogg',
	[CHAR_SOUND_IMA_TIRED] = 'IMA TIRED.ogg',
	[CHAR_SOUND_LETS_A_GO] = 'Lets_a_go.ogg',
}

-- All Located in "actors"
--local CAPTABLE_CHAR = {
    --normal = smlua_model_util_get_id("custom_model_cap_normal_geo"),
    --wing = smlua_model_util_get_id("custom_model_cap_wing_geo"),
    --metal = smlua_model_util_get_id("custom_model_cap_metal_geo"),
    --metalWing = smlua_model_util_get_id("custom_model_cap_wing_geo"),
--}

--local E_MODEL_CUSTOM_STAR = smlua_model_util_get_id("custom_model_star_geo") -- Located in "actors"

local PALETTE_CHAR = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "ffffff",
    [GLOVES] = "ffffff",
    [SHOES]  = "ffffff",
    [HAIR]   = "ffffff",
    [SKIN]   = "ffffff",
    [CAP]    = "ffffff",
}

--[[
-- All Located in "textures"
local healthMeter = {
    label = {
        left = get_texture_info("template-hp-back-left"),
        right = get_texture_info("template-hp-back-right"),
    },
    pie = {
        [1] = get_texture_info("template-hp-pie-1"),
        [2] = get_texture_info("template-hp-pie-2"),
        [3] = get_texture_info("template-hp-pie-3"),
        [4] = get_texture_info("template-hp-pie-4"),
        [5] = get_texture_info("template-hp-pie-5"),
        [6] = get_texture_info("template-hp-pie-6"),
        [7] = get_texture_info("template-hp-pie-7"),
        [8] = get_texture_info("template-hp-pie-8"),
    }
}
]]

--[[
    Note: If there are some functionalities you don't care
    to add such as palettes, you can freely remove the function
    for it, the only function you require is character_add
]]

local CSloaded = false
local function on_character_select_load()
    CT_CHAR = _G.charSelect.character_add("Watto", {"They show up, They look around, They no Buy", "Why they no buy"}, "Dee Kay (Porting, Setup)  & Ze_Boyy (VA)", {r = 255, g = 200, b = 200}, E_MODEL_CUSTOM_MODEL, CT_WARIO, TEX_CUSTOM_LIFE_ICON)
    --_G.charSelect.character_add_caps(E_MODEL_CUSTOM_MODEL, CAPTABLE_CHAR)
    _G.charSelect.character_add_voice(E_MODEL_CUSTOM_MODEL, VOICETABLE_CHAR)
   -- _G.charSelect.character_add_celebration_star(E_MODEL_CUSTOM_MODEL, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_CUSTOM_MODEL, PALETTE_CHAR)
    --_G.charSelect.character_add_health_meter(CT_CHAR, healthMeter)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)